Subject: Re: SSH proxy connection doesn't work for tunnel only accounts

From: Pajula Juha <[email-masked]>
Date: Tue, 3 Mar 2020 09:57:56 +0000

On Tue, 21 Aug 2018 16:38:24 +0300 Arcadie Cracan <[email-masked]<mailto:[email-masked]>> wrote:

> Package: x2goclient

> Version: 4.1.2.1

> Tag: patch

> I use a ssh proxy server that allows only tunnel connections (i.e. doesn't

> allow the users to use the shell). After upgrading from Ubuntu 16.04 to

> 18.04 x2goclient stopped working with my ssh proxy server.

> I believe the reason for this is the call to the "checkLogin()" function

> even for ssh proxy connections (which in my opinion is not necessary).

> I attach a patch that makes x2goclient skip the checkLogin() call (as it

> does for kerberos connections) for the ssh proxy connection.

> Thank you for considering this patch.

> Kind regards,

>    Arcadie Cracan

I can confirm that the bug exists still on latest version 4.1.2.2-2020.02.13.

It prevents using newer versions of X2GO (4.1.x) with Bastion host type of ssh proxies where proxy account is jailed to use only ssh (no shell is allowed).

The connections work fine with version 4.0.5.2-2016.09.20, but not newer.

This is clearly visible on debug messages with latest version:

x2go-DEBUG-../src/sshmasterconnection.cpp:943> state: 1

x2go-DEBUG-../src/sshmasterconnection.cpp:676> Setting SSH directory to C:/xxxxxxx

x2go-DEBUG-../src/sshmasterconnection.cpp:1324> Trying to authenticate user with private key.

x2go-DEBUG-../src/sshmasterconnection.cpp:1507> Authenticating with key: 0

x2go-DEBUG-../src/sshmasterconnection.cpp:687> User authentication OK.

x2go-DEBUG-../src/sshmasterconnection.cpp:1708> LOGIN CHECK:"This account is currently not available.

"

x2go-DEBUG-../src/sshmasterconnection.cpp:1744> LOOP FINISHED

x2go-DEBUG-../src/sshmasterconnection.cpp:1754> Reconnect session

x2go-DEBUG-../src/sshmasterconnection.cpp:707> Login Check - Failed

x2go-DEBUG-../src/onmainwindow.cpp:3051> SSH Session prompt:"This account is currently not available.

"

x2go-DEBUG-../src/onmainwindow.cpp:3054> SSH Session interaction

x2go-DEBUG-../src/sshmasterconnection.cpp:437> SSH proxy interaction finished

Regards,

-Juha Pajula